var __create = Object.create;
var __defProp = Object.defineProperty;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __markAsModule = (target) => __defProp(target, "__esModule", {value: true});
var __commonJS = (callback, module2) => () => {
  if (!module2) {
    module2 = {exports: {}};
    callback(module2.exports, module2);
  }
  return module2.exports;
};
var __export = (target, all) => {
  __markAsModule(target);
  for (var name in all)
    __defProp(target, name, {get: all[name], enumerable: true});
};
var __exportStar = (target, module2, desc) => {
  __markAsModule(target);
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, {get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable});
  }
  return target;
};
var __toModule = (module2) => {
  if (module2 && module2.__esModule)
    return module2;
  return __exportStar(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", {value: module2, enumerable: true}), module2);
};

// node_modules_prod/topojson-client/dist/topojson-client.js
var require_topojson_client = __commonJS((exports2, module2) => {
  (function(global, factory) {
    typeof exports2 === "object" && typeof module2 !== "undefined" ? factory(exports2) : typeof define === "function" && define.amd ? define(["exports"], factory) : (global = global || self, factory(global.topojson = global.topojson || {}));
  })(exports2, function(exports3) {
    "use strict";
    function identity(x) {
      return x;
    }
    function transform2(transform3) {
      if (transform3 == null)
        return identity;
      var x0, y0, kx = transform3.scale[0], ky = transform3.scale[1], dx = transform3.translate[0], dy = transform3.translate[1];
      return function(input, i) {
        if (!i)
          x0 = y0 = 0;
        var j = 2, n = input.length, output = new Array(n);
        output[0] = (x0 += input[0]) * kx + dx;
        output[1] = (y0 += input[1]) * ky + dy;
        while (j < n)
          output[j] = input[j], ++j;
        return output;
      };
    }
    function bbox(topology) {
      var t = transform2(topology.transform), key, x0 = Infinity, y0 = x0, x1 = -x0, y1 = -x0;
      function bboxPoint(p) {
        p = t(p);
        if (p[0] < x0)
          x0 = p[0];
        if (p[0] > x1)
          x1 = p[0];
        if (p[1] < y0)
          y0 = p[1];
        if (p[1] > y1)
          y1 = p[1];
      }
      function bboxGeometry(o) {
        switch (o.type) {
          case "GeometryCollection":
            o.geometries.forEach(bboxGeometry);
            break;
          case "Point":
            bboxPoint(o.coordinates);
            break;
          case "MultiPoint":
            o.coordinates.forEach(bboxPoint);
            break;
        }
      }
      topology.arcs.forEach(function(arc) {
        var i = -1, n = arc.length, p;
        while (++i < n) {
          p = t(arc[i], i);
          if (p[0] < x0)
            x0 = p[0];
          if (p[0] > x1)
            x1 = p[0];
          if (p[1] < y0)
            y0 = p[1];
          if (p[1] > y1)
            y1 = p[1];
        }
      });
      for (key in topology.objects) {
        bboxGeometry(topology.objects[key]);
      }
      return [x0, y0, x1, y1];
    }
    function reverse(array, n) {
      var t, j = array.length, i = j - n;
      while (i < --j)
        t = array[i], array[i++] = array[j], array[j] = t;
    }
    function feature2(topology, o) {
      if (typeof o === "string")
        o = topology.objects[o];
      return o.type === "GeometryCollection" ? {type: "FeatureCollection", features: o.geometries.map(function(o2) {
        return feature$1(topology, o2);
      })} : feature$1(topology, o);
    }
    function feature$1(topology, o) {
      var id = o.id, bbox2 = o.bbox, properties = o.properties == null ? {} : o.properties, geometry = object(topology, o);
      return id == null && bbox2 == null ? {type: "Feature", properties, geometry} : bbox2 == null ? {type: "Feature", id, properties, geometry} : {type: "Feature", id, bbox: bbox2, properties, geometry};
    }
    function object(topology, o) {
      var transformPoint = transform2(topology.transform), arcs = topology.arcs;
      function arc(i, points) {
        if (points.length)
          points.pop();
        for (var a = arcs[i < 0 ? ~i : i], k = 0, n = a.length; k < n; ++k) {
          points.push(transformPoint(a[k], k));
        }
        if (i < 0)
          reverse(points, n);
      }
      function point(p) {
        return transformPoint(p);
      }
      function line(arcs2) {
        var points = [];
        for (var i = 0, n = arcs2.length; i < n; ++i)
          arc(arcs2[i], points);
        if (points.length < 2)
          points.push(points[0]);
        return points;
      }
      function ring(arcs2) {
        var points = line(arcs2);
        while (points.length < 4)
          points.push(points[0]);
        return points;
      }
      function polygon(arcs2) {
        return arcs2.map(ring);
      }
      function geometry(o2) {
        var type = o2.type, coordinates;
        switch (type) {
          case "GeometryCollection":
            return {type, geometries: o2.geometries.map(geometry)};
          case "Point":
            coordinates = point(o2.coordinates);
            break;
          case "MultiPoint":
            coordinates = o2.coordinates.map(point);
            break;
          case "LineString":
            coordinates = line(o2.arcs);
            break;
          case "MultiLineString":
            coordinates = o2.arcs.map(line);
            break;
          case "Polygon":
            coordinates = polygon(o2.arcs);
            break;
          case "MultiPolygon":
            coordinates = o2.arcs.map(polygon);
            break;
          default:
            return null;
        }
        return {type, coordinates};
      }
      return geometry(o);
    }
    function stitch(topology, arcs) {
      var stitchedArcs = {}, fragmentByStart = {}, fragmentByEnd = {}, fragments = [], emptyIndex = -1;
      arcs.forEach(function(i, j) {
        var arc = topology.arcs[i < 0 ? ~i : i], t;
        if (arc.length < 3 && !arc[1][0] && !arc[1][1]) {
          t = arcs[++emptyIndex], arcs[emptyIndex] = i, arcs[j] = t;
        }
      });
      arcs.forEach(function(i) {
        var e = ends(i), start = e[0], end = e[1], f, g;
        if (f = fragmentByEnd[start]) {
          delete fragmentByEnd[f.end];
          f.push(i);
          f.end = end;
          if (g = fragmentByStart[end]) {
            delete fragmentByStart[g.start];
            var fg = g === f ? f : f.concat(g);
            fragmentByStart[fg.start = f.start] = fragmentByEnd[fg.end = g.end] = fg;
          } else {
            fragmentByStart[f.start] = fragmentByEnd[f.end] = f;
          }
        } else if (f = fragmentByStart[end]) {
          delete fragmentByStart[f.start];
          f.unshift(i);
          f.start = start;
          if (g = fragmentByEnd[start]) {
            delete fragmentByEnd[g.end];
            var gf = g === f ? f : g.concat(f);
            fragmentByStart[gf.start = g.start] = fragmentByEnd[gf.end = f.end] = gf;
          } else {
            fragmentByStart[f.start] = fragmentByEnd[f.end] = f;
          }
        } else {
          f = [i];
          fragmentByStart[f.start = start] = fragmentByEnd[f.end = end] = f;
        }
      });
      function ends(i) {
        var arc = topology.arcs[i < 0 ? ~i : i], p0 = arc[0], p1;
        if (topology.transform)
          p1 = [0, 0], arc.forEach(function(dp) {
            p1[0] += dp[0], p1[1] += dp[1];
          });
        else
          p1 = arc[arc.length - 1];
        return i < 0 ? [p1, p0] : [p0, p1];
      }
      function flush(fragmentByEnd2, fragmentByStart2) {
        for (var k in fragmentByEnd2) {
          var f = fragmentByEnd2[k];
          delete fragmentByStart2[f.start];
          delete f.start;
          delete f.end;
          f.forEach(function(i) {
            stitchedArcs[i < 0 ? ~i : i] = 1;
          });
          fragments.push(f);
        }
      }
      flush(fragmentByEnd, fragmentByStart);
      flush(fragmentByStart, fragmentByEnd);
      arcs.forEach(function(i) {
        if (!stitchedArcs[i < 0 ? ~i : i])
          fragments.push([i]);
      });
      return fragments;
    }
    function mesh(topology) {
      return object(topology, meshArcs.apply(this, arguments));
    }
    function meshArcs(topology, object2, filter) {
      var arcs, i, n;
      if (arguments.length > 1)
        arcs = extractArcs(topology, object2, filter);
      else
        for (i = 0, arcs = new Array(n = topology.arcs.length); i < n; ++i)
          arcs[i] = i;
      return {type: "MultiLineString", arcs: stitch(topology, arcs)};
    }
    function extractArcs(topology, object2, filter) {
      var arcs = [], geomsByArc = [], geom;
      function extract0(i) {
        var j = i < 0 ? ~i : i;
        (geomsByArc[j] || (geomsByArc[j] = [])).push({i, g: geom});
      }
      function extract1(arcs2) {
        arcs2.forEach(extract0);
      }
      function extract2(arcs2) {
        arcs2.forEach(extract1);
      }
      function extract3(arcs2) {
        arcs2.forEach(extract2);
      }
      function geometry(o) {
        switch (geom = o, o.type) {
          case "GeometryCollection":
            o.geometries.forEach(geometry);
            break;
          case "LineString":
            extract1(o.arcs);
            break;
          case "MultiLineString":
          case "Polygon":
            extract2(o.arcs);
            break;
          case "MultiPolygon":
            extract3(o.arcs);
            break;
        }
      }
      geometry(object2);
      geomsByArc.forEach(filter == null ? function(geoms) {
        arcs.push(geoms[0].i);
      } : function(geoms) {
        if (filter(geoms[0].g, geoms[geoms.length - 1].g))
          arcs.push(geoms[0].i);
      });
      return arcs;
    }
    function planarRingArea2(ring) {
      var i = -1, n = ring.length, a, b = ring[n - 1], area = 0;
      while (++i < n)
        a = b, b = ring[i], area += a[0] * b[1] - a[1] * b[0];
      return Math.abs(area);
    }
    function merge(topology) {
      return object(topology, mergeArcs.apply(this, arguments));
    }
    function mergeArcs(topology, objects) {
      var polygonsByArc = {}, polygons = [], groups = [];
      objects.forEach(geometry);
      function geometry(o) {
        switch (o.type) {
          case "GeometryCollection":
            o.geometries.forEach(geometry);
            break;
          case "Polygon":
            extract(o.arcs);
            break;
          case "MultiPolygon":
            o.arcs.forEach(extract);
            break;
        }
      }
      function extract(polygon) {
        polygon.forEach(function(ring) {
          ring.forEach(function(arc) {
            (polygonsByArc[arc = arc < 0 ? ~arc : arc] || (polygonsByArc[arc] = [])).push(polygon);
          });
        });
        polygons.push(polygon);
      }
      function area(ring) {
        return planarRingArea2(object(topology, {type: "Polygon", arcs: [ring]}).coordinates[0]);
      }
      polygons.forEach(function(polygon) {
        if (!polygon._) {
          var group = [], neighbors2 = [polygon];
          polygon._ = 1;
          groups.push(group);
          while (polygon = neighbors2.pop()) {
            group.push(polygon);
            polygon.forEach(function(ring) {
              ring.forEach(function(arc) {
                polygonsByArc[arc < 0 ? ~arc : arc].forEach(function(polygon2) {
                  if (!polygon2._) {
                    polygon2._ = 1;
                    neighbors2.push(polygon2);
                  }
                });
              });
            });
          }
        }
      });
      polygons.forEach(function(polygon) {
        delete polygon._;
      });
      return {
        type: "MultiPolygon",
        arcs: groups.map(function(polygons2) {
          var arcs = [], n;
          polygons2.forEach(function(polygon) {
            polygon.forEach(function(ring) {
              ring.forEach(function(arc) {
                if (polygonsByArc[arc < 0 ? ~arc : arc].length < 2) {
                  arcs.push(arc);
                }
              });
            });
          });
          arcs = stitch(topology, arcs);
          if ((n = arcs.length) > 1) {
            for (var i = 1, k = area(arcs[0]), ki, t; i < n; ++i) {
              if ((ki = area(arcs[i])) > k) {
                t = arcs[0], arcs[0] = arcs[i], arcs[i] = t, k = ki;
              }
            }
          }
          return arcs;
        }).filter(function(arcs) {
          return arcs.length > 0;
        })
      };
    }
    function bisect(a, x) {
      var lo = 0, hi = a.length;
      while (lo < hi) {
        var mid = lo + hi >>> 1;
        if (a[mid] < x)
          lo = mid + 1;
        else
          hi = mid;
      }
      return lo;
    }
    function neighbors(objects) {
      var indexesByArc = {}, neighbors2 = objects.map(function() {
        return [];
      });
      function line(arcs, i2) {
        arcs.forEach(function(a) {
          if (a < 0)
            a = ~a;
          var o = indexesByArc[a];
          if (o)
            o.push(i2);
          else
            indexesByArc[a] = [i2];
        });
      }
      function polygon(arcs, i2) {
        arcs.forEach(function(arc) {
          line(arc, i2);
        });
      }
      function geometry(o, i2) {
        if (o.type === "GeometryCollection")
          o.geometries.forEach(function(o2) {
            geometry(o2, i2);
          });
        else if (o.type in geometryType)
          geometryType[o.type](o.arcs, i2);
      }
      var geometryType = {
        LineString: line,
        MultiLineString: polygon,
        Polygon: polygon,
        MultiPolygon: function(arcs, i2) {
          arcs.forEach(function(arc) {
            polygon(arc, i2);
          });
        }
      };
      objects.forEach(geometry);
      for (var i in indexesByArc) {
        for (var indexes = indexesByArc[i], m = indexes.length, j = 0; j < m; ++j) {
          for (var k = j + 1; k < m; ++k) {
            var ij = indexes[j], ik = indexes[k], n;
            if ((n = neighbors2[ij])[i = bisect(n, ik)] !== ik)
              n.splice(i, 0, ik);
            if ((n = neighbors2[ik])[i = bisect(n, ij)] !== ij)
              n.splice(i, 0, ij);
          }
        }
      }
      return neighbors2;
    }
    function untransform(transform3) {
      if (transform3 == null)
        return identity;
      var x0, y0, kx = transform3.scale[0], ky = transform3.scale[1], dx = transform3.translate[0], dy = transform3.translate[1];
      return function(input, i) {
        if (!i)
          x0 = y0 = 0;
        var j = 2, n = input.length, output = new Array(n), x1 = Math.round((input[0] - dx) / kx), y1 = Math.round((input[1] - dy) / ky);
        output[0] = x1 - x0, x0 = x1;
        output[1] = y1 - y0, y0 = y1;
        while (j < n)
          output[j] = input[j], ++j;
        return output;
      };
    }
    function quantize(topology, transform3) {
      if (topology.transform)
        throw new Error("already quantized");
      if (!transform3 || !transform3.scale) {
        if (!((n = Math.floor(transform3)) >= 2))
          throw new Error("n must be \u22652");
        box = topology.bbox || bbox(topology);
        var x0 = box[0], y0 = box[1], x1 = box[2], y1 = box[3], n;
        transform3 = {scale: [x1 - x0 ? (x1 - x0) / (n - 1) : 1, y1 - y0 ? (y1 - y0) / (n - 1) : 1], translate: [x0, y0]};
      } else {
        box = topology.bbox;
      }
      var t = untransform(transform3), box, key, inputs = topology.objects, outputs = {};
      function quantizePoint(point) {
        return t(point);
      }
      function quantizeGeometry(input) {
        var output;
        switch (input.type) {
          case "GeometryCollection":
            output = {type: "GeometryCollection", geometries: input.geometries.map(quantizeGeometry)};
            break;
          case "Point":
            output = {type: "Point", coordinates: quantizePoint(input.coordinates)};
            break;
          case "MultiPoint":
            output = {type: "MultiPoint", coordinates: input.coordinates.map(quantizePoint)};
            break;
          default:
            return input;
        }
        if (input.id != null)
          output.id = input.id;
        if (input.bbox != null)
          output.bbox = input.bbox;
        if (input.properties != null)
          output.properties = input.properties;
        return output;
      }
      function quantizeArc(input) {
        var i = 0, j = 1, n2 = input.length, p, output = new Array(n2);
        output[0] = t(input[0], 0);
        while (++i < n2)
          if ((p = t(input[i], i))[0] || p[1])
            output[j++] = p;
        if (j === 1)
          output[j++] = [0, 0];
        output.length = j;
        return output;
      }
      for (key in inputs)
        outputs[key] = quantizeGeometry(inputs[key]);
      return {
        type: "Topology",
        bbox: box,
        transform: transform3,
        objects: outputs,
        arcs: topology.arcs.map(quantizeArc)
      };
    }
    exports3.bbox = bbox;
    exports3.feature = feature2;
    exports3.merge = merge;
    exports3.mergeArcs = mergeArcs;
    exports3.mesh = mesh;
    exports3.meshArcs = meshArcs;
    exports3.neighbors = neighbors;
    exports3.quantize = quantize;
    exports3.transform = transform2;
    exports3.untransform = untransform;
    Object.defineProperty(exports3, "__esModule", {value: true});
  });
});

// src/index.js
__export(exports, {
  filter: () => filter_default,
  filterAttached: () => filterAttached_default,
  filterAttachedWeight: () => filterAttachedWeight_default,
  filterWeight: () => filterWeight_default,
  planarRingArea: () => planarRingArea,
  planarTriangleArea: () => planarTriangleArea,
  presimplify: () => presimplify_default,
  quantile: () => quantile_default,
  simplify: () => simplify_default,
  sphericalRingArea: () => sphericalRingArea,
  sphericalTriangleArea: () => sphericalTriangleArea
});

// src/prune.js
function prune_default(topology) {
  var oldObjects = topology.objects, newObjects = {}, oldArcs = topology.arcs, oldArcsLength = oldArcs.length, oldIndex = -1, newIndexByOldIndex = new Array(oldArcsLength), newArcsLength = 0, newArcs, newIndex = -1, key;
  function scanGeometry(input) {
    switch (input.type) {
      case "GeometryCollection":
        input.geometries.forEach(scanGeometry);
        break;
      case "LineString":
        scanArcs(input.arcs);
        break;
      case "MultiLineString":
        input.arcs.forEach(scanArcs);
        break;
      case "Polygon":
        input.arcs.forEach(scanArcs);
        break;
      case "MultiPolygon":
        input.arcs.forEach(scanMultiArcs);
        break;
    }
  }
  function scanArc(index) {
    if (index < 0)
      index = ~index;
    if (!newIndexByOldIndex[index])
      newIndexByOldIndex[index] = 1, ++newArcsLength;
  }
  function scanArcs(arcs) {
    arcs.forEach(scanArc);
  }
  function scanMultiArcs(arcs) {
    arcs.forEach(scanArcs);
  }
  function reindexGeometry(input) {
    var output;
    switch (input.type) {
      case "GeometryCollection":
        output = {type: "GeometryCollection", geometries: input.geometries.map(reindexGeometry)};
        break;
      case "LineString":
        output = {type: "LineString", arcs: reindexArcs(input.arcs)};
        break;
      case "MultiLineString":
        output = {type: "MultiLineString", arcs: input.arcs.map(reindexArcs)};
        break;
      case "Polygon":
        output = {type: "Polygon", arcs: input.arcs.map(reindexArcs)};
        break;
      case "MultiPolygon":
        output = {type: "MultiPolygon", arcs: input.arcs.map(reindexMultiArcs)};
        break;
      default:
        return input;
    }
    if (input.id != null)
      output.id = input.id;
    if (input.bbox != null)
      output.bbox = input.bbox;
    if (input.properties != null)
      output.properties = input.properties;
    return output;
  }
  function reindexArc(oldIndex2) {
    return oldIndex2 < 0 ? ~newIndexByOldIndex[~oldIndex2] : newIndexByOldIndex[oldIndex2];
  }
  function reindexArcs(arcs) {
    return arcs.map(reindexArc);
  }
  function reindexMultiArcs(arcs) {
    return arcs.map(reindexArcs);
  }
  for (key in oldObjects) {
    scanGeometry(oldObjects[key]);
  }
  newArcs = new Array(newArcsLength);
  while (++oldIndex < oldArcsLength) {
    if (newIndexByOldIndex[oldIndex]) {
      newIndexByOldIndex[oldIndex] = ++newIndex;
      newArcs[newIndex] = oldArcs[oldIndex];
    }
  }
  for (key in oldObjects) {
    newObjects[key] = reindexGeometry(oldObjects[key]);
  }
  return {
    type: "Topology",
    bbox: topology.bbox,
    transform: topology.transform,
    objects: newObjects,
    arcs: newArcs
  };
}

// src/filter.js
function filter_default(topology, filter) {
  var oldObjects = topology.objects, newObjects = {}, key;
  if (filter == null)
    filter = filterTrue;
  function filterGeometry(input) {
    var output, arcs;
    switch (input.type) {
      case "Polygon": {
        arcs = filterRings(input.arcs);
        output = arcs ? {type: "Polygon", arcs} : {type: null};
        break;
      }
      case "MultiPolygon": {
        arcs = input.arcs.map(filterRings).filter(filterIdentity);
        output = arcs.length ? {type: "MultiPolygon", arcs} : {type: null};
        break;
      }
      case "GeometryCollection": {
        arcs = input.geometries.map(filterGeometry).filter(filterNotNull);
        output = arcs.length ? {type: "GeometryCollection", geometries: arcs} : {type: null};
        break;
      }
      default:
        return input;
    }
    if (input.id != null)
      output.id = input.id;
    if (input.bbox != null)
      output.bbox = input.bbox;
    if (input.properties != null)
      output.properties = input.properties;
    return output;
  }
  function filterRings(arcs) {
    return arcs.length && filterExteriorRing(arcs[0]) ? [arcs[0]].concat(arcs.slice(1).filter(filterInteriorRing)) : null;
  }
  function filterExteriorRing(ring) {
    return filter(ring, false);
  }
  function filterInteriorRing(ring) {
    return filter(ring, true);
  }
  for (key in oldObjects) {
    newObjects[key] = filterGeometry(oldObjects[key]);
  }
  return prune_default({
    type: "Topology",
    bbox: topology.bbox,
    transform: topology.transform,
    objects: newObjects,
    arcs: topology.arcs
  });
}
function filterTrue() {
  return true;
}
function filterIdentity(x) {
  return x;
}
function filterNotNull(geometry) {
  return geometry.type != null;
}

// src/filterAttached.js
function filterAttached_default(topology) {
  var ownerByArc = new Array(topology.arcs.length), ownerIndex = 0, key;
  function testGeometry(o) {
    switch (o.type) {
      case "GeometryCollection":
        o.geometries.forEach(testGeometry);
        break;
      case "Polygon":
        testArcs(o.arcs);
        break;
      case "MultiPolygon":
        o.arcs.forEach(testArcs);
        break;
    }
  }
  function testArcs(arcs) {
    for (var i = 0, n = arcs.length; i < n; ++i, ++ownerIndex) {
      for (var ring = arcs[i], j = 0, m = ring.length; j < m; ++j) {
        var arc = ring[j];
        if (arc < 0)
          arc = ~arc;
        var owner = ownerByArc[arc];
        if (owner == null)
          ownerByArc[arc] = ownerIndex;
        else if (owner !== ownerIndex)
          ownerByArc[arc] = -1;
      }
    }
  }
  for (key in topology.objects) {
    testGeometry(topology.objects[key]);
  }
  return function(ring) {
    for (var j = 0, m = ring.length, arc; j < m; ++j) {
      if (ownerByArc[(arc = ring[j]) < 0 ? ~arc : arc] === -1) {
        return true;
      }
    }
    return false;
  };
}

// src/filterWeight.js
var import_topojson_client = __toModule(require_topojson_client());

// src/planar.js
function planarTriangleArea(triangle) {
  var a = triangle[0], b = triangle[1], c = triangle[2];
  return Math.abs((a[0] - c[0]) * (b[1] - a[1]) - (a[0] - b[0]) * (c[1] - a[1])) / 2;
}
function planarRingArea(ring) {
  var i = -1, n = ring.length, a, b = ring[n - 1], area = 0;
  while (++i < n)
    a = b, b = ring[i], area += a[0] * b[1] - a[1] * b[0];
  return Math.abs(area) / 2;
}

// src/filterWeight.js
function filterWeight_default(topology, minWeight, weight) {
  minWeight = minWeight == null ? Number.MIN_VALUE : +minWeight;
  if (weight == null)
    weight = planarRingArea;
  return function(ring, interior) {
    return weight(import_topojson_client.feature(topology, {type: "Polygon", arcs: [ring]}).geometry.coordinates[0], interior) >= minWeight;
  };
}

// src/filterAttachedWeight.js
function filterAttachedWeight_default(topology, minWeight, weight) {
  var a = filterAttached_default(topology), w = filterWeight_default(topology, minWeight, weight);
  return function(ring, interior) {
    return a(ring, interior) || w(ring, interior);
  };
}

// src/presimplify.js
var import_topojson_client2 = __toModule(require_topojson_client());

// src/heap.js
function compare(a, b) {
  return a[1][2] - b[1][2];
}
function heap_default() {
  var heap = {}, array = [], size = 0;
  heap.push = function(object) {
    up(array[object._ = size] = object, size++);
    return size;
  };
  heap.pop = function() {
    if (size <= 0)
      return;
    var removed = array[0], object;
    if (--size > 0)
      object = array[size], down(array[object._ = 0] = object, 0);
    return removed;
  };
  heap.remove = function(removed) {
    var i = removed._, object;
    if (array[i] !== removed)
      return;
    if (i !== --size)
      object = array[size], (compare(object, removed) < 0 ? up : down)(array[object._ = i] = object, i);
    return i;
  };
  function up(object, i) {
    while (i > 0) {
      var j = (i + 1 >> 1) - 1, parent = array[j];
      if (compare(object, parent) >= 0)
        break;
      array[parent._ = i] = parent;
      array[object._ = i = j] = object;
    }
  }
  function down(object, i) {
    while (true) {
      var r = i + 1 << 1, l = r - 1, j = i, child = array[j];
      if (l < size && compare(array[l], child) < 0)
        child = array[j = l];
      if (r < size && compare(array[r], child) < 0)
        child = array[j = r];
      if (j === i)
        break;
      array[child._ = i] = child;
      array[object._ = i = j] = object;
    }
  }
  return heap;
}

// src/presimplify.js
function copy(point) {
  return [point[0], point[1], 0];
}
function presimplify_default(topology, weight) {
  var point = topology.transform ? import_topojson_client2.transform(topology.transform) : copy, heap = heap_default();
  if (weight == null)
    weight = planarTriangleArea;
  var arcs = topology.arcs.map(function(arc) {
    var triangles = [], maxWeight = 0, triangle, i, n;
    arc = arc.map(point);
    for (i = 1, n = arc.length - 1; i < n; ++i) {
      triangle = [arc[i - 1], arc[i], arc[i + 1]];
      triangle[1][2] = weight(triangle);
      triangles.push(triangle);
      heap.push(triangle);
    }
    arc[0][2] = arc[n][2] = Infinity;
    for (i = 0, n = triangles.length; i < n; ++i) {
      triangle = triangles[i];
      triangle.previous = triangles[i - 1];
      triangle.next = triangles[i + 1];
    }
    while (triangle = heap.pop()) {
      var previous = triangle.previous, next = triangle.next;
      if (triangle[1][2] < maxWeight)
        triangle[1][2] = maxWeight;
      else
        maxWeight = triangle[1][2];
      if (previous) {
        previous.next = next;
        previous[2] = triangle[2];
        update(previous);
      }
      if (next) {
        next.previous = previous;
        next[0] = triangle[0];
        update(next);
      }
    }
    return arc;
  });
  function update(triangle) {
    heap.remove(triangle);
    triangle[1][2] = weight(triangle);
    heap.push(triangle);
  }
  return {
    type: "Topology",
    bbox: topology.bbox,
    objects: topology.objects,
    arcs
  };
}

// src/quantile.js
function quantile_default(topology, p) {
  var array = [];
  topology.arcs.forEach(function(arc) {
    arc.forEach(function(point) {
      if (isFinite(point[2])) {
        array.push(point[2]);
      }
    });
  });
  return array.length && quantile(array.sort(descending), p);
}
function quantile(array, p) {
  if (!(n = array.length))
    return;
  if ((p = +p) <= 0 || n < 2)
    return array[0];
  if (p >= 1)
    return array[n - 1];
  var n, h = (n - 1) * p, i = Math.floor(h), a = array[i], b = array[i + 1];
  return a + (b - a) * (h - i);
}
function descending(a, b) {
  return b - a;
}

// src/simplify.js
function simplify_default(topology, minWeight) {
  minWeight = minWeight == null ? Number.MIN_VALUE : +minWeight;
  var arcs = topology.arcs.map(function(input) {
    var i = -1, j = 0, n = input.length, output = new Array(n), point;
    while (++i < n) {
      if ((point = input[i])[2] >= minWeight) {
        output[j++] = [point[0], point[1]];
      }
    }
    output.length = j;
    return output;
  });
  return {
    type: "Topology",
    transform: topology.transform,
    bbox: topology.bbox,
    objects: topology.objects,
    arcs
  };
}

// src/spherical.js
var pi = Math.PI;
var tau = 2 * pi;
var quarterPi = pi / 4;
var radians = pi / 180;
var abs = Math.abs;
var atan2 = Math.atan2;
var cos = Math.cos;
var sin = Math.sin;
function halfArea(ring, closed) {
  var i = 0, n = ring.length, sum = 0, point = ring[closed ? i++ : n - 1], lambda0, lambda1 = point[0] * radians, phi1 = point[1] * radians / 2 + quarterPi, cosPhi0, cosPhi1 = cos(phi1), sinPhi0, sinPhi1 = sin(phi1);
  for (; i < n; ++i) {
    point = ring[i];
    lambda0 = lambda1, lambda1 = point[0] * radians;
    phi1 = point[1] * radians / 2 + quarterPi;
    cosPhi0 = cosPhi1, cosPhi1 = cos(phi1);
    sinPhi0 = sinPhi1, sinPhi1 = sin(phi1);
    var dLambda = lambda1 - lambda0, sdLambda = dLambda >= 0 ? 1 : -1, adLambda = sdLambda * dLambda, k = sinPhi0 * sinPhi1, u = cosPhi0 * cosPhi1 + k * cos(adLambda), v = k * sdLambda * sin(adLambda);
    sum += atan2(v, u);
  }
  return sum;
}
function sphericalRingArea(ring, interior) {
  var sum = halfArea(ring, true);
  if (interior)
    sum *= -1;
  return (sum < 0 ? tau + sum : sum) * 2;
}
function sphericalTriangleArea(t) {
  return abs(halfArea(t, false)) * 2;
}
//# sourceMappingURL=topojson-simplify.js.map
